"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var urlhandler_common_1 = require("./urlhandler.common");
var getappdelegate_1 = require("./getappdelegate");
var urlhandler_common_2 = require("./urlhandler.common");
exports.handleOpenURL = urlhandler_common_2.handleOpenURL;
exports.appDelegate = getappdelegate_1.getAppDelegate();
function enableMultipleOverridesFor(classRef, methodName) {
    var prefix = '_';
    Object.defineProperty(classRef.prototype, prefix + methodName, {
        value: classRef.prototype[methodName] || (function () { }),
        writable: true
    });
    Object.defineProperty(classRef.prototype, methodName, {
        get: function () {
            return classRef.prototype[prefix + methodName];
        },
        set: function (nextImplementation) {
            var currentImplementation = classRef.prototype[prefix + methodName];
            classRef.prototype[prefix + methodName] = function () {
                var result = currentImplementation.apply(void 0, Array.from(arguments));
                return nextImplementation.apply(void 0, Array.from(arguments).concat([result]));
            };
        }
    });
}
enableMultipleOverridesFor(exports.appDelegate, 'applicationDidFinishLaunchingWithOptions');
exports.appDelegate.prototype.applicationDidFinishLaunchingWithOptions = function (application, launchOptions) {
    if (launchOptions != null) {
        var urlOptions = launchOptions.valueForKey('UIApplicationLaunchOptionsURLKey');
        if (urlOptions) {
            var appURL = urlhandler_common_1.extractAppURL(urlOptions);
            if (appURL != null) {
                urlhandler_common_1.getCallback()(appURL);
            }
        }
    }
    return true;
};
enableMultipleOverridesFor(exports.appDelegate, 'applicationOpenURLOptions');
exports.appDelegate.prototype.applicationOpenURLOptions = function (application, url, options) {
    var lastArgument = arguments[arguments.length - 1];
    var previousResult = lastArgument !== options ? lastArgument : undefined;
    if (!previousResult) {
        var appURL = urlhandler_common_1.extractAppURL(url.absoluteString);
        if (appURL != null) {
            urlhandler_common_1.getCallback()(appURL);
        }
        return true;
    }
    return previousResult;
};
enableMultipleOverridesFor(exports.appDelegate, 'continueUserActivity');
exports.appDelegate.prototype.continueUserActivity = function (application, userActivity) {
    if (userActivity.activityType === NSUserActivityTypeBrowsingWeb) {
        var appURL = urlhandler_common_1.extractAppURL(userActivity.webpageURL);
        if (appURL !== null) {
            urlhandler_common_1.getCallback()(appURL);
        }
    }
    return true;
};
//# sourceMappingURL=urlhandler.ios.js.map